package pl.psnc.dlibramuseum.app.extension.csv;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;
import java.util.Map;

import junit.framework.Assert;
import junit.framework.JUnit4TestAdapter;

import org.junit.Test;

public class CSVDictionaryManagerTest {

    @Test
    public void readGoodFileTest() {
        CSVDictionaryManager csvDictionaryManager = new CSVDictionaryManager();
        
        InputStream is = CSVDictionaryManagerTest.class.getResourceAsStream("res/example-ok.csv");

        Map<String, List<String>> data = null;
        try {
            data = csvDictionaryManager.readParseFile(is, 0, null);
        } catch (IOException e) {
        }

        Assert.assertNotNull(data);
        Assert.assertEquals(5, data.size());  //W pliku 'example-ok.csv' jest 6 linii ale tylko 5 z danymi 
    }

    @Test
    public void readBadFileTest() {
        CSVDictionaryManager csvDictionaryManager = new CSVDictionaryManager();

        InputStream is = CSVDictionaryManagerTest.class.getResourceAsStream("res/example-fail.csv");

        Map<String, List<String>> data = null;
        try {
            data = csvDictionaryManager.readParseFile(is, 0, null);
        } catch (IOException e) {
        }

        Assert.assertNotNull(data);
        Assert.assertFalse(data.size() == 5);
        Assert.assertNull(data.get("Bolesław Prus"));
    }

    @Test
    public void multipleTest() {
        CSVDictionaryManager csvDictionaryManager = new CSVDictionaryManager();

        InputStream is = CSVDictionaryManagerTest.class.getResourceAsStream("res/example-multiple.csv");

        Map<String, List<String>> data = null;
        try {
            data = csvDictionaryManager.readParseFile(is, 0, null);
        } catch (IOException e) {
        }

        Assert.assertNotNull(data);
        Assert.assertTrue(data.get("Bolesław Prus").size() == 1);
        Assert.assertTrue(data.get("Czesław Niemen").size() == 1);
    }

    public static junit.framework.Test suite() {
        return new JUnit4TestAdapter(CSVDictionaryManagerTest.class);
    }

}
