/*
 * Copyright (c) 2000 Poznan Supercomputing and Networking Center
 * 10 Noskowskiego Street, Poznan, Wielkopolska 61-704, Poland
 * All rights reserved.
 *
 * This software is the confidential and proprietary information of
 * Poznan Supercomputing and Networking Center ("Confidential Information").
 * You shall not disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you entered into
 * with PSNC.
 */
package pl.psnc.dlibra.app.extension.dm.dictcopy;

import java.text.MessageFormat;

import pl.psnc.dlibra.app.common.component.inprogress.OperationInProgressManager;

/**
 * @version 
 */
public class DictLoaderListener
	implements DictionaryLoaderListener
{

	private final OperationInProgressManager manager;

	private final String messagePattern;


	public DictLoaderListener(OperationInProgressManager manager,
			String messagePattern)
	{
		this.manager = manager;
		this.messagePattern = messagePattern;
	}


	public void inProgress(int current, int maximum)
	{
		manager.initializeProgressBar(0, maximum);
		manager.updateProgressBar(current, false);
		manager.setProgressInfo(MessageFormat.format(messagePattern, current++,
			maximum));

	}
}
