package pl.psnc.dlibra.app.extension.fh.jpg;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

public class FileInfoEditingPanel
	extends JPanel
{

	private FileInfo selectedValue;
	private JTextArea descriptionText;
	private JTextArea commentText;
	private JLabel descriptionLabel;
	private JLabel commentLabel;


	public FileInfoEditingPanel()
	{
		initialize();
	}


	private void initialize()
	{
		setLayout(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();
		c.weightx = 1;
		c.fill = GridBagConstraints.HORIZONTAL;
		c.insets = new Insets(0, 0, 5, 0);
		JLabel informationLabel = new JLabel("information about file:");
//		add(informationLabel, c);

		c = new GridBagConstraints();
		c.weightx = 1;
		c.gridy = 1;
		c.fill = GridBagConstraints.HORIZONTAL;
		c.insets = new Insets(0, 0, 2, 0);
		descriptionLabel = new JLabel("description:");
		add(descriptionLabel, c);

		c = new GridBagConstraints();
		c.weightx = 1;
		c.weighty = 1;
		c.gridy = 2;
		c.insets = new Insets(0, 0, 10, 0);
		c.fill = GridBagConstraints.BOTH;
		descriptionText = new JTextArea();
		descriptionText.setFont(new JLabel().getFont());
		add(new JScrollPane(descriptionText), c);

		c = new GridBagConstraints();
		c.weightx = 1;
		c.gridy = 3;
		c.insets = new Insets(0, 0, 2, 0);
		c.fill = GridBagConstraints.HORIZONTAL;
		commentLabel = new JLabel("comment:");
		add(commentLabel, c);

		c = new GridBagConstraints();
		c.weightx = 1;
		c.weighty = 1;
		c.gridy = 4;
		c.insets = new Insets(0, 0, 10, 0);
		c.fill = GridBagConstraints.BOTH;
		commentText = new JTextArea();
		commentText.setFont(new JLabel().getFont());
		add(new JScrollPane(commentText), c);

		setBorder(BorderFactory
				.createTitledBorder("information about file"));

	}


	public void setObject(FileInfo selectedValue)
	{
		this.selectedValue = selectedValue;
		commentText.setText(selectedValue.getComment());
		descriptionText.setText(selectedValue.getDescription());
	}


	public void applyChanges()
	{
		if (selectedValue == null) {
			return;
		}
		selectedValue.setComment(commentText.getText().trim());
		selectedValue.setDescription(descriptionText.getText().trim());
	}


	public void setResourceBundle(ResourceBundle textsBundle)
	{
		initializeGUITexts(textsBundle);
	}


	private void initializeGUITexts(ResourceBundle textsBundle)
	{
		setBorder(BorderFactory
			.createTitledBorder(textsBundle.getString("fileInfoEditor.title")));
		descriptionLabel.setText(textsBundle.getString("descriptionLabel.text"));
		commentLabel.setText(textsBundle.getString("commentLabel.text"));
	}
}
