/*
 * Copyright (c) 2010 Poznan Supercomputing and Networking Center
 * 10 Noskowskiego Street, Poznan, Wielkopolska 61-704, Poland
 * All rights reserved.
 *
 * This software is the confidential and proprietary information of
 * Poznan Supercomputing and Networking Center ("Confidential Information").
 * You shall not disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you entered into
 * with PSNC.
 */
package pl.psnc.dlibra.app.extension.fh.jpg;

import java.io.File;
import java.io.FileNotFoundException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import pl.psnc.dlibra.app.extension.Extension;
import pl.psnc.dlibra.app.extension.fileparser.FileParser;

public class JPGFHFileParser
	implements FileParser, Extension
{

	@Override
	public List<URL> parseFile(URL fileURL)
		throws FileNotFoundException, Exception
	{
		String path = fileURL.getPath();
		String fileName = new File(path).getName();
		String parentPath = path.substring(0, path.length() - fileName.length());
		URL parentURL = new URL(fileURL, parentPath);
		List<URL> result = new ArrayList<URL>();
		XMLDescriptionFileParser parser = new XMLDescriptionFileParser(fileURL);
		for (FileInfo fileInfo : parser.parse()) {
			result.add(new URL(parentURL, fileInfo.getFilePath()));
		}
		return result;
	}


	@Override
	public boolean supports(URL fileURL)
	{
		String path = fileURL.getPath();
		String fileName = new File(path).getName();
		return ListOfObjectsEditor.PRESENTATION_DATA_FILENAME.equals(fileName);
	}


	@Override
	public void initialize(Map<String, Object> initPrefs)
	{
		// nothing to initialize
	}


	@Override
	public String toString()
	{
		return "JPG presentation XML file parser";
	}

}
