/*
 * Copyright (c) 2005 Poznan Supercomputing and Networking Center
 * 10 Noskowskiego Street, Poznan, Wielkopolska 61-704, Poland
 * All rights reserved.
 *
 * This software is the confidential and proprietary information of
 * Poznan Supercomputing and Networking Center ("Confidential Information").
 * You shall not disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you entered into
 * with PSNC.
 */
package pl.psnc.dlibra.content.extraction;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

/**
 * Class for extracting content of text files.
 * @version $Id: TXTTextualContentExtractor.java,v 1.2 2007/11/23 08:51:03 helin Exp $
 */
public class TXTTextualContentExtractor
	implements TextualContentExtractor
{

	private static final String TEXT_PLAIN = "text/plain";


	public String getTextualContent(File file, String mimeType, String version,
			Integer pageNumber, File mainFile)
		throws IOException
	{
		BufferedReader br = new BufferedReader(new FileReader(file));
		StringBuffer sb = new StringBuffer();
		while (br.ready()) {
			String line = br.readLine();
			if (line != null) {
				sb.append(line);
			}
		}
		br.close();

		sb.append("\n");
		sb.append(TextualContentExtractor.CONTENT_SEPARATOR_PREFIX);
		sb.append(" ");
		sb.append(TextualContentExtractor.CONTENT_SEPARATOR_FILE);
		sb.append(version);
		sb.append(" ");
		sb.append(TextualContentExtractor.CONTENT_SEPARATOR_PAGE);
		if (pageNumber == null)
			pageNumber = Integer.valueOf(1);
		sb.append(pageNumber);
		sb.append(" ");
		sb.append(TextualContentExtractor.CONTENT_SEPARATOR_SUFFIX);

		return sb.toString();
	}


	public boolean isAbleToExtract(String path, String mimeType)
	{
		return TEXT_PLAIN.equals(mimeType);
	}

}
