/*
 * Copyright (c) 2005 Poznan Supercomputing and Networking Center
 * 10 Noskowskiego Street, Poznan, Wielkopolska 61-704, Poland
 * All rights reserved.
 *
 * This software is the confidential and proprietary information of
 * Poznan Supercomputing and Networking Center ("Confidential Information").
 * You shall not disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you entered into
 * with PSNC.
 */
package com.lizardtech.djvu;

import java.io.IOException;
import java.io.InputStream;

import org.apache.log4j.Logger;

/**
 * Subclass of DjVu class for supporting references between DjVu files.
 * @version $Id: DLibraDjVuPage.java,v 1.1 2007/08/27 08:13:38 helin Exp $
 */
public class DLibraDjVuPage
	extends DjVuPage
{

	@Override
	protected void parseSjbz(InputStream input)
		throws IOException
	{
		try {
			super.parseSjbz(input);
		}
		catch (IllegalStateException e) {
			//This error may occur when a shape dictionary that should be 
			//included from external file is missing (see 
			//decodeInclude(CachedInputStream) method in this file).
			logger.debug("Error while processing Sjbz chunk!", e);
		}
	}

	/**
	 * Logger for this class
	 */
	private static final Logger logger = Logger.getLogger(DLibraDjVuPage.class);


	@Override
	protected void decodeInclude(CachedInputStream pool)
		throws IOException
	{
		try {
			super.decodeInclude(pool);
		}
		catch (IOException e) {
			//If inclusion fails then we should continue processing - it is 
			//nothing wrong when extracting text.
			logger.debug("Inclusion failed!", e);
		}
	}

}
