package pl.psnc.dlibra.content.extraction;

import java.net.URI;

import lius.config.LiusConfig;
import lius.config.LiusConfigBuilder;

import org.java.plugin.Plugin;

/**
 * Plugin class for LIUS initialisation.
 * 
 * @version $Id: LIUSTextualContentExtractorPlugin.java,v 1.2 2007/11/23 08:51:02 helin Exp $
 */
public class LIUSTextualContentExtractorPlugin
	extends Plugin
{

	@Override
	protected void doStart()
		throws Exception
	{
		String location = getDescriptor().getLocation().toExternalForm();
		String liusPath = getDescriptor().getAttribute("liusConfigFile")
				.getValue();
		URI uri = URI.create(location.substring(0, location.length() - 11) + liusPath);
		String filePath = uri.getRawPath();
		
		LiusConfig lc = LiusConfigBuilder.getSingletonInstance().getLiusConfig(
			filePath);
		LIUSTextualContentExtractor.setLiusConfig(lc);
	}


	@Override
	protected void doStop()
		throws Exception
	{
		// nothing to do here.
	}

}
