/*
 * Copyright (c) 2000 Poznan Supercomputing and Networking Center
 * 10 Noskowskiego Street, Poznan, Wielkopolska 61-704, Poland
 * All rights reserved.
 *
 * This software is the confidential and proprietary information of
 * Poznan Supercomputing and Networking Center ("Confidential Information").
 * You shall not disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you entered into
 * with PSNC.
 */
package com.lizardtech.djvu;

import java.io.IOException;
import java.io.InputStream;

import javax.crypto.Cipher;


/**
 * @version 
 */
public class CipherInputStream
	extends InputStream
{

	private final Cipher c;
	private final InputStream encrypted;
	public CipherInputStream(Cipher c, InputStream encrypted) {
		this.c = c;
		this.encrypted = encrypted;
	}
	/* (non-Javadoc)
	 * @see java.io.InputStream#read()
	 */
	@Override
	public int read()
		throws IOException
	{
		encrypted.read();
		return 0;
	}
	
	@Override
	public void close()
		throws IOException
	{
		super.close();
		encrypted.close();
	}

	
}
