/*
 * Copyright (c) 2000 Poznan Supercomputing and Networking Center
 * 10 Noskowskiego Street, Poznan, Wielkopolska 61-704, Poland
 * All rights reserved.
 *
 * This software is the confidential and proprietary information of
 * Poznan Supercomputing and Networking Center ("Confidential Information").
 * You shall not disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you entered into
 * with PSNC.
 */

package javax.swing;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;

import pl.psnc.dlibra.ps.applet.VersionProvider;
import pl.psnc.util.crypto.CryptoUtils;

/**
 * An EditorPane that supports encrypted content.
 * @version $Id: JCustomEditorPane.java,v 1.4 2006-05-29 13:36:09 mwerla Exp $
 */
public class JCustomEditorPane
	extends JEditorPane
{

	private CryptoUtils utils;


	/**
	 * Constructor
	 */
	public JCustomEditorPane()
	{
		super();
	}


	/**
	 * @param type
	 * @param text
	 */
	public JCustomEditorPane(String type, String text)
	{
		super(type, text);
	}


	/**
	 * @param url
	 * @throws IOException
	 */
	public JCustomEditorPane(String url)
		throws IOException
	{
		super(url);
	}


	/**
	 * @param initialPage
	 * @throws IOException
	 */
	public JCustomEditorPane(URL initialPage)
		throws IOException
	{
		super(initialPage);
	}


	/**
	 * @param utils CryptoUtils
	 */
	public void setCryptoUtils(CryptoUtils utils)
	{
		this.utils = utils;
	}


	@Override
	protected InputStream getStream(URL page)
		throws IOException
	{
		URLConnection connection = page.openConnection();
		connection.setRequestProperty("User-Agent", "dLibra-html-plugin/"
			+ VersionProvider.getVersion() + " (http://dlibra.psnc.pl/)");
		
		InputStream in = connection.getInputStream();

		if (!getContentType().equals("text/html")) {			
			return utils.getDecipheredInputStream(in);
		}
		return in;
	}
}
