/*
 * Copyright (c) 2000 Poznan Supercomputing and Networking Center
 * 10 Noskowskiego Street, Poznan, Wielkopolska 61-704, Poland
 * All rights reserved.
 *
 * This software is the confidential and proprietary information of
 * Poznan Supercomputing and Networking Center ("Confidential Information").
 * You shall not disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you entered into
 * with PSNC.
 */

package javax.swing.text;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.StringWriter;

import pl.psnc.util.crypto.CryptoUtils;

/**
 * An HTMLEditorKit that supports encrypted content.
 * @version $Id: ViewerStyledEditorKit.java,v 1.3 2006-05-29 13:36:10 mwerla Exp $
 */
public class ViewerStyledEditorKit
	extends StyledEditorKit
{

	private static CryptoUtils utils;


	/**
	 * @param utils Crypto utils to set
	 */
	public static void setCryptoUtils(CryptoUtils utils)
	{
		ViewerStyledEditorKit.utils = utils;
	}


	@Override
	public void read(Reader in, Document doc, int pos)
		throws IOException, BadLocationException
	{
		if (in instanceof InputStreamReader && utils.isKeySet()) {
			StringWriter stringWriter = new StringWriter();
			char[] buff = new char[4096];
			int charsRead = 0;

			while ((charsRead = in.read(buff)) > 0) {
				stringWriter.write(buff, 0, charsRead);
			}

			in.close();

			ByteArrayInputStream byteArrayInputStream;
			byteArrayInputStream = new ByteArrayInputStream(stringWriter
					.toString().getBytes());

			super.read(new InputStreamReader(utils
					.getDecipheredInputStream(byteArrayInputStream)), doc, pos);
		}
		else {
			super.read(in, doc, pos);
		}
	}
}
