/*
 * Copyright (c) 2011 Poznan Supercomputing and Networking Center
 * 10 Noskowskiego Street, Poznan, Wielkopolska 61-704, Poland
 * All rights reserved.
 *
 * This software is the confidential and proprietary information of
 * Poznan Supercomputing and Networking Center ("Confidential Information").
 * You shall not disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you entered into
 * with PSNC.
 */
package pl.psnc.dlibra.applet.jpg.viewer;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import pl.psnc.util.IOUtils;

public class VersionProvider
{
	
	private static final String UNKNOWN_VERSION_STRING = "unknownVersion";
	private static final String VERSION_PROPERTIES_FILE_LOCATION = "/version.properties";


	public static String getVersion()
		throws IOException
	{
		InputStream buildStream = IOUtils.class.getResourceAsStream(VERSION_PROPERTIES_FILE_LOCATION);

		if (buildStream != null) {
			Properties buildProps = new Properties();
			buildProps.load(buildStream);

			return buildProps.getProperty("version.number", UNKNOWN_VERSION_STRING);
		}
		return UNKNOWN_VERSION_STRING;
	}
}