/*
 * Copyright (c) 2011 Poznan Supercomputing and Networking Center
 * 10 Noskowskiego Street, Poznan, Wielkopolska 61-704, Poland
 * All rights reserved.
 *
 * This software is the confidential and proprietary information of
 * Poznan Supercomputing and Networking Center ("Confidential Information").
 * You shall not disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you entered into
 * with PSNC.
 */
package pl.psnc.dlibra.applet.jpg.viewer;

import java.io.IOException;
import java.util.Properties;

import javax.swing.JApplet;
import javax.swing.SwingWorker;

/**
 * An applet for viewing secured dLibra JPG publications.
 */
public class ViewerApplet
	extends JApplet
{
	static Properties lang;


	@Override
	public void init()
	{
		super.init();

		final String sessionId = getParameter("sessionId");
		final String initialUrl = getParameter("initialUrl");
		loadLang(getParameter("userLang"));

		final JPGViewerPanel viewerPanel = new JPGViewerPanel();
		getContentPane().add(viewerPanel, java.awt.BorderLayout.CENTER);
		viewerPanel.showMessage(lang.getProperty("connecting.message"));

		new SwingWorker<Object, Object>() {

			@Override
			protected Object doInBackground()
				throws Exception
			{
				ConnectionManager connectionManager = new ConnectionManager(
						initialUrl, sessionId);
				viewerPanel.setConnectionManager(connectionManager);
				return null;
			}


			protected void done()
			{
				try {
					get();
					viewerPanel.start();
				}
				catch (Exception e) {
					viewerPanel.showError(e.getCause() != null ? e.getCause()
							: e);
				}
			};

		}.execute();
	}


	private void loadLang(String userLang)
	{
		lang = new Properties();
		try {
			lang.load(getClass().getResourceAsStream(
				"/pl/psnc/dlibra/applet/jpg/viewer/res/GUI_" + userLang
						+ ".properties"));
		}
		catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

}
